﻿using System;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace ELTE.Net.SyncTcpClients
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Booting clients...");
            for (Int32 i = 100; i < 110; i++)
            {
                Thread.Sleep(500);
                Thread clientThread = new Thread(RunClient); // a klienseket külön szálban futtatjuk
                clientThread.Start(i);
            }
        }

        /// <summary>
        /// Kliens folyamat.
        /// </summary>
        /// <param name="id">Kliens azonosítósja.</param>
        private static void RunClient(Object id)
        {
            TcpClient tcpClient = new TcpClient(); // kliens

            try
            {
                tcpClient.Connect(IPAddress.Parse("127.0.0.1"), 3000); // kapcsolódás egy távoli ponthoz
                if (tcpClient.Connected) // ha sikerült kapcsolódni
                {
                    NetworkStream networkStream = tcpClient.GetStream(); // hálózati adatfolyam, amelyre helyezhetjük az adatokat

                    StreamWriter writer = new StreamWriter(networkStream); // folyamíró
                    writer.WriteLine("Hello! I'm client nr. " + id + "!"); // üzenet a szervernek
                    writer.Flush(); // üzenet elküldése

                    StreamReader reader = new StreamReader(networkStream); // folyamolvasó
                    String message = reader.ReadLine(); // szerver üzenetének olvasása
                    Console.WriteLine("Client " + id + ", receive: " + message);

                    for (Int32 i = 0; i < 10; i++)
                    {
                        Thread.Sleep(1000);
                        writer.WriteLine((i + 1).ToString());
                        writer.Flush();

                        message = reader.ReadLine();
                        Console.WriteLine("Client " + id + ", receive: " + message);
                    }

                    tcpClient.Close();
                }
            }
            catch (Exception)
            {
                if (tcpClient.Connected)
                    tcpClient.Close(); // kapcsolat bezárása
            }
        }
    }
}
