﻿using System.Windows;
using System.Windows.Input;
using ELTE.Net.GameServer.Shared;

namespace ELTE.Net.BallGame.Client.View
{
    /// <summary>
    /// Interaction logic for GameBrowserWindow.xaml
    /// </summary>
    public partial class GameBrowserWindow : Window
    {
        private Game[] _Games;

        /// <summary>
        /// Játékok lekérdezése, vagy beállítása.
        /// </summary>
        public Game[] Games { get { return _Games; } set { _Games = value; _DataGridGames.ItemsSource = _Games; } }

        /// <summary>
        /// Kiválasztott játék lekérdezése.
        /// </summary>
        public Game SelectedGame 
        { 
            get 
            {
                if (_Games != null && _DataGridGames.SelectedIndex >= 0)
                    return _Games[_DataGridGames.SelectedIndex];
                else
                    return null;
            } 
        }

        public GameBrowserWindow()
        {
            InitializeComponent();
     
            _DataGridGames.MouseDoubleClick += new MouseButtonEventHandler(DataGridGames_MouseDoubleClick);
        }

        private void DataGridGames_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            if (_DataGridGames.SelectedIndex >= 0)
            {
                DialogResult = true;
                Close();
            }
        }

        private void ButtonConnect_Click(object sender, RoutedEventArgs e)
        {
            if (_DataGridGames.SelectedIndex >= 0)
            {
                DialogResult = true;
                Close();
            }
        }
    }
}
