﻿using System;
using System.Xml.Serialization;

namespace ELTE.Net.GameServer.Shared
{
    /// <summary>
    /// Játékos típusa.
    /// </summary>
    public class Player
    {
        /// <summary>
        /// Játékos azonosító lekérdezése, vagy beállítása.
        /// </summary>
        [XmlAttribute]
        public Int32 PlayerId { get; set; }
        /// <summary>
        /// Játékosnév lekérdezése, vagy beállítása.
        /// </summary>
        [XmlAttribute]
        public String PlayerName { get; set; }

        /// <summary>
        /// Egyenlőségvizsgálat.
        /// </summary>
        /// <param name="obj">A másik objektum.</param>
        /// <returns>Igaz, ha a két objektum egyenlő.</returns>
        public override Boolean Equals(object obj)
        {
            if (obj is Player)
            {
                return PlayerId == (obj as Player).PlayerId;
            }
            else
            {
                return false;
            }
        }
    }
}
